from time import time
from datetime import datetime
import math
from pandac.PandaModules import Point3

def getSunPos(DTIME):
	""" 	Red Sun rises in East sets in West (sector 1) y=0
		Green Sun Rises in North sets in South (sector1) x=0
		Blue Sun circles world equator z=0
		
		periods:
		red sun: 	23311 s
		green sun: 	33161 s
		blue sun:	44711 s
	"""
	rAngle=((DTIME % 23311)/23311)*(math.pi*2.0)
	gAngle=((DTIME % 33161)/33161)*(math.pi*2.0)
	bAngle=((DTIME % 44711)/44711)*(math.pi*2.0)
	#print 'ANGLES',rAngle,gAngle,bAngle,DTIME
	return (Point3(math.cos(rAngle),0,math.sin(rAngle)),
		Point3(0,-math.cos(gAngle),math.sin(gAngle)),
		Point3(-math.cos(bAngle),math.sin(bAngle),0) )
	
go=True
#tsec=int(time())
tsec=1200000000
while go==True:
	red,green,blue=getSunPos(float(tsec))
	new=''
	if abs(red.getX()-green.getX())<0.01 and abs(red.getY()-green.getY())<0.01 and abs(red.getZ()-green.getZ())<0.01:
		if tsec>=0:
			new='Red-Green at '+ str(datetime.fromtimestamp(float(tsec)))+' '+str(tsec)+' pos:'+str(red)+','+str(green)+"\n"
		else:
			new='Red-Green at '+ str(tsec)+' pos:'+str(red)+','+str(green)+"\n"

	if abs(red.getX()-blue.getX())<0.01 and abs(red.getY()-blue.getY())<0.01 and abs(red.getZ()-blue.getZ())<0.01:
		if tsec>=0:
			new='Red-Blue at '+ str(datetime.fromtimestamp(float(tsec)))+' '+str(tsec)+' pos:'+str(red)+','+str(blue)+"\n"
		else:
			new='Red-Blue at '+ str(tsec)+' pos:'+str(red)+','+str(blue)+"\n"
	
	if abs(blue.getX()-green.getX())<0.01 and abs(blue.getY()-green.getY())<0.01 and abs(blue.getZ()-green.getZ())<0.01:
		if tsec>=0:
			new='Blue-Green at '+ str(datetime.fromtimestamp(float(tsec)))+' '+str(tsec)+' pos:'+str(blue)+','+str(green)+"\n"
		else:
			new='Blue-Green at '+ str(tsec)+' pos:'+str(blue)+','+str(green)+"\n"
		
	if new!='':
		print new
		confile=open('minorConjuncts.txt','a')
		confile.write(new)
		confile.close()
		
	if tsec % 1000000==0:
		print tsec
		confile=open('minorConjuncts.txt','a')
		confile.write('time:'+str(tsec)+"\n")
		confile.close()
		
	tsec=tsec+1
	
