from time import time
from datetime import datetime
import math
from pandac.PandaModules import Point3

def getSunPos(DTIME):
	""" 	Red Sun rises in East sets in West (sector 1) y=0
		Green Sun Rises in North sets in South (sector1) x=0
		Blue Sun circles world equator z=0
		
		periods:
		red sun: 	23311 s
		green sun: 	33161 s
		blue sun:	44711 s
	"""
	rAngle=((DTIME % 23311)/23311)*(math.pi*2.0)
	gAngle=((DTIME % 33161)/33161)*(math.pi*2.0)
	bAngle=((DTIME % 44711)/44711)*(math.pi*2.0)
	#print 'ANGLES',rAngle,gAngle,bAngle,DTIME
	return (Point3(math.cos(rAngle),0,math.sin(rAngle)),
		Point3(0,-math.cos(gAngle),math.sin(gAngle)),
		Point3(-math.cos(bAngle),math.sin(bAngle),0) )
	
go=True
#tsec=int(time())
tsec=406000000
while go==True:
	red,green,blue=getSunPos(float(tsec))
	new=''
	redmatch=greenmatch=bluematch='no'
	if (abs(red.getX()-1)<0.001 and abs(red.getY()-0)<0.001 and abs(red.getZ()-0)<0.001):
		redmatch='pos'
	if (abs(red.getX()+1)<0.001 and abs(red.getY()-0)<0.001 and abs(red.getZ()-0)<0.001):
		redmatch='neg'	
	if abs(green.getX()-0)<0.001 and abs(green.getY()-1)<0.001 and abs(green.getZ()-0)<0.001:
		greenmatch='pos'
	if abs(green.getX()-0)<0.001 and abs(green.getY()+1)<0.001 and abs(green.getZ()-0)<0.001:
		greenmatch='neg'
	if abs(blue.getX()-1)<0.001 and abs(blue.getY()-0)<0.001 and abs(blue.getZ()-0)<0.001:
		bluematch='pos'
	if abs(blue.getX()+1)<0.001 and abs(blue.getY()-0)<0.001 and abs(blue.getZ()-0)<0.001:
		bluematch='neg'
	if redmatch!='no' and greenmatch != 'no' and bluematch != 'no':	
		if tsec>=0:
			new='Match at '+ str(datetime.fromtimestamp(float(tsec)))+' '+str(tsec)+' POSITION:'+redmatch+':'+greenmatch+':'+bluematch+"\n"
		else:
			new='Match at '+ str(tsec)+' pos:'+redmatch+':'+greenmatch+':'+bluematch+"\n"

		
	if new!='':
		print new
		confile=open('tripleHorizon.txt','a')
		confile.write(new)
		confile.close()
		
	if tsec % 1000000==0:
		print tsec
		confile=open('tripleHorizon.txt','a')
		confile.write('time:'+str(tsec)+"\n")
		confile.close()
		
	tsec=tsec+1
	
