__author__='sigilis.com'
__version__='0.1.12'
from direct.actor.Actor import Actor
from direct.showbase.DirectObject import DirectObject
from direct.gui.DirectGui import DirectFrame
from pandac.PandaModules import Vec3, GeomNode,Point3
from direct.task.Task import Task
from direct.gui.OnscreenText import OnscreenText
from pandac.PandaModules import PandaNode,NodePath,Camera,TextNode,Filename    
from pandac.PandaModules import CollisionTraverser,CollisionNode,CollisionHandlerFloor,CollisionHandlerPusher
from pandac.PandaModules import CollisionHandlerQueue,CollisionRay,BitMask32
from pandac.PandaModules import CollisionSphere,CollisionSegment,CollisionHandlerEvent

import math

VIZRAD=100000

class Avatar(Actor,DirectObject):
	def __init__(self,user=None,terrain=None,
			sx=None,sy=None,sz=None,eyeheight=None):
		self.user=user		
		models="avatars/%s" % self.user.modelType		
		anims=None
		self.keyMap = {"left":0, "right":0, "forward":0, "back":0,  
				"cam-left":0, "cam-right":0,
				"jump":0,"moused1":0,"moused2":0,"moused3":0}	
		Actor.__init__(self,models,anims)
		self.terrain=terrain
		self.showHUD()
		self.getHeight()
		self.isMoving=False
		self.isFlying=False
		self.headchange=True
		self.cammove=False
		self.keyed=False
		self.ooBody=False
		self.firstperson=False
		self.runLoop=False
		self.accepting=True
		self.eyeheight=eyeheight
		if sx!=None and sy!=None:
			self.reparentTo(render)
			if sz==None:
				StartPos=Vec3(sx,sy,self.terrain.getRealElev(sx,sy)+10)
			else:
				StartPos=Vec3(sx,sy,sz)
			self.setFluidPos(StartPos)
			print 'startpos',StartPos
			self.setLastPos()	
			self.myCAMNode=base.camNode
			self.myCAM=base.camera
			self.myCAMLENS=base.camLens
			self.myCAM.setPos(StartPos.getX(),StartPos.getY()+5,StartPos.getZ()+(self.height*1.1))
			print "cam",self.myCAM.getPos()
			self.myCAMLENS.setFar(VIZRAD)	
			#self.myCAMLENS.setFov(60,40)
			self.myCAM.lookAt(self)
			taskMgr.add(self.move,"moveTask")
			self.prevtime = 0
			self.count=0
			self.setXYZ()
			self.setMoveKeys()		
			self.initCollider()
			self.HUDInfo()
			self.setCollideMask(BitMask32.allOff())
			#self.ls()
			self.setBodyParts()
			
	def initCollider(self):
	        self.cTrav = CollisionTraverser()
		self.cTrav.setRespectPrevTransform(True)

		self.GroundRay = CollisionRay(0,0,100000,0,0,-1)
		
		self.GroundCol = CollisionNode('GroundRay')
		self.GroundCol.setFromCollideMask(BitMask32.bit(20))
		print 'raycollide',self.GroundCol.getFromCollideMask()
		self.GroundCol.setIntoCollideMask(BitMask32.allOff())
		self.GroundColNp = self.attachNewNode(self.GroundCol)
		self.GroundColNp.node().addSolid(self.GroundRay)
#		self.GroundHandler = CollisionHandlerQueue()
		self.GroundHandler = CollisionHandlerFloor()
		self.cTrav.addCollider(self.GroundColNp, self.GroundHandler)
		self.GroundHandler.addCollider(self.GroundColNp,self)
	

		self.camGroundRay = CollisionRay(0,0,20000,0,0,-1)
		self.camGroundCol = CollisionNode('camGroundRay')
		self.camGroundCol.setFromCollideMask(GeomNode.getDefaultCollideMask())
		self.camGroundCol.setIntoCollideMask(BitMask32.allOff())
		self.camGroundColNp = self.myCAM.attachNewNode(self.camGroundCol)
		self.camGroundColNp.node().addSolid(self.camGroundRay)
		self.camGroundHandler = CollisionHandlerQueue()
		self.cTrav.addCollider(self.camGroundColNp, self.camGroundHandler)
		
				
		self.collSphere=CollisionSphere(Point3(0,0,self.height/2+self.height/8), self.height/2-self.height/8)
		self.collSphere.setTangible(1)
		self.collSphereCol = CollisionNode('collSphere')
		self.collSphereCol.setFromCollideMask(BitMask32.bit(19))
		self.collSphereCol.setIntoCollideMask(BitMask32.bit(19))
		self.collSphereNP = self.attachNewNode(self.collSphereCol)
		self.collSphereNP.setScale(.5,.5,1)
		self.collSphereNP.node().addSolid(self.collSphere)
		#self.collSphereNP.show()
		self.collSphereHandler = CollisionHandlerPusher()
		self.cTrav.addCollider(self.collSphereNP, self.collSphereHandler)
		self.collSphereHandler.addCollider(self.collSphereNP,self)
		
		self.pickerRay=CollisionRay()
		self.pickerNode=CollisionNode('mouseRay')
		mask=BitMask32.bit(19) | BitMask32.bit(20)
		self.pickerNode.setFromCollideMask(mask)
		self.pickerNode.setIntoCollideMask(BitMask32.allOff())
		self.pickerNP=self.myCAM.attachNewNode(self.pickerNode)
		self.pickerNode.addSolid(self.pickerRay)
		self.mouseHandler=CollisionHandlerQueue()
		self.cTrav.addCollider(self.pickerNP, self.mouseHandler)
		
		# Uncomment this line to see the collision rays
		self.GroundColNp.show()
		#self.camGroundColNp.show()	
		#self.collSphereNP.show()
		#self.collSegNP.show()
		#self.ls()
		
		#Uncomment this line to show a visual representation of the 
		#collisions occuring
		self.cTrav.showCollisions(self.collSphereNP)
		
	def collPrint(self,obj):	
		print 'collided with:',obj
		
	def runAnim(self):
		if self.isMoving is False:
			#self.loop("run")
			#self.setPlayRate(100,'run')
			self.isMoving = True 
			if self.runLoop==False:
				self.runMagic('Run',None)
			else:
				self.runLoop.resume()
			
	def walkAnim(self):
		if self.isMoving:
			#self.stop()
			#self.pose("walk",5)
			self.lhip.setH(0)
			self.rhip.setH(0)
			self.lknee.setP(0)
			self.rknee.setP(0)
			self.isMoving = False
			self.runLoop.pause()
			
	def setXYZ(self):
		(self.rX,self.rY)=self.terrain.getTerrainXY(self.getX(),self.getY())
		if (int(self.rX)!=self.lastX or int(self.rY)!= self.lastY):
			print int(self.rX),int(self.rY)	
			print "setting focal point"
			self.lastX=int(self.rX)
			self.lastY=int(self.rY)
			if self.user.client.connected==True:
				self.user.client.sendMsgPos(True)
		if self.user.twoway != False:		
			self.user.twoway.sendMsgPos()		
			
	def setLastPos(self): 	
		self.lastX,self.lastY= self.terrain.getTerrainXY(self.getX(),self.getY());    		
	
	#Records the state of the arrow keys
    	def setKey(self, key, value):
	    	self.keyMap[key] = value	
		
	def setMoveKeys(self):
		self.accept("arrow_left", self.setKey, ["left",1])
		self.accept("arrow_right", self.setKey, ["right",1])
		self.accept("arrow_up", self.setKey, ["forward",1])
		self.accept("arrow_down", self.setKey, ["back",1])
		self.accept("s", self.setKey, ["cam-left",1])
		self.accept("a", self.setKey, ["cam-right",1])
		self.accept("arrow_left-up", self.setKey, ["left",0])
		self.accept("arrow_right-up", self.setKey, ["right",0])
		self.accept("arrow_up-up", self.setKey, ["forward",0])
		self.accept("arrow_down-up", self.setKey, ["back",0])
		self.accept("s-up", self.setKey, ["cam-left",0])
		self.accept("a-up", self.setKey, ["cam-right",0])
		self.accept("j", self.setKey, ["jump",1])
		self.accept("j-up", self.setKey, ["jump",0])
		
		##extra camera keys
		self.accept("1",self.firstPerson)
		self.accept("2",self.outOfBody)
		
		#command KEY
		self.accept("control-g",self.runCommand)
		
		#fly key
		self.accept("control-f",self.flying)
		
		#magic KEY
		#magicVARS=['JumpTo',(2000,1000)]
		#magicVARS=['Joints',None]
		#magicVARS=['BigHead',(2,3)]
		magicVARS=['Fly',None]
		self.accept("control-m",self.runMagic,magicVARS)
		
		self.accept("control-p",self.takePhoto,['map'+str(self.rX)+'-'+str(self.rY)+'.jpg'])
		
		#self.accept("mouse1", self.setKey, ["moused1",1])
		#self.accept("mouse1-up", self.setKey, ["moused1",0])
		#self.accept("mouse2", self.setKey, ["moused2",1])
		#self.accept("mouse2-up", self.setKey, ["moused2",0])
		#self.accept("mouse3", self.setKey, ["moused3",1])
		#self.accept("mouse3-up", self.setKey, ["moused3",0])
		
		
	def outOfBody(self):
		if self.accepting==True:
			if self.ooBody==False:
				self.ooBody=True
				self.lastCamPos=self.myCAM.getPos()
				self.myCAM.setFluidPos(self.getX(),self.getY(),self.getZ()+500)
				self.myCAM.lookAt(self)
			else:
				if self.ooBody<10:
					self.ooBody=self.ooBody+1
					self.myCAM.setFluidPos(self.getX(),self.getY(),self.myCAM.getZ()+500)
					self.myCAM.lookAt(self)
				else:	
					self.ooBody=False
					self.myCAM.setFluidPos(self.lastCamPos)
					self.myCAM.lookAt(self.getX(),self.getY(),self.getZ()+self.height/2)
	
	def flying(self):
		if self.isFlying==False:
			self.isFlying=True
			self.skeleton.setP(90)
			self.collSphereNP.setP(90)
			self.collSphereNP.setPos(self.collSphereNP.getX(),self.collSphereNP.getY()+self.height/2,self.collSphereNP.getZ()+self.height/2)
		else:
			self.isFlying=False
			self.skeleton.setScale(1)
			self.skeleton.setP(0)
			self.collSphereNP.setP(0)
			self.collSphereNP.setPos(self.collSphereNP.getX(),self.collSphereNP.getY()-self.height/2,self.collSphereNP.getZ()-self.height/2)
			self.setXYZ()
			
	def firstPerson(self):
		if self.firstperson==False:
			self.firstperson=True
			self.lastCamPos=self.myCAM.getPos()
			self.hide()
			#angle=(self.getH()/360)*2*math.pi
			#self.myCAM.setPos(1.2*math.cos(angle)+self.getX(),1.2*math.sin(angle)+self.getY(),self.getZ()+self.eyeheight)
			self.myCAM.setFluidPos(self.getX(),self.getY(),self.getZ()+self.height)
			#print 'angle',angle,10*math.cos(angle)+self.getX(),10*math.sin(angle)+self.getY(),self.getZ()+self.eyeheight
			#self.myCAM.lookAt(10*math.cos(angle)+self.getX(),10*math.sin(angle)+self.getY(),self.getZ()+6)
			self.myCAM.setH(self.getH()-180)
			self.myCAM.setP(-10)
			self.myCAMLENS.setFov(80,60)
		else:
			self.firstperson=False
			self.show()
			self.myCAM.setFluidPos(self.lastCamPos)
			self.myCAMLENS.setFov(80,60)
			self.myCAM.lookAt(self)
			
			
	def showHUD(self):
		#print self.parent
		if self.user.widescreen=='yes':
			xpos=1.2
		else:
			xpos=1.0
		
		self.infoFrame = DirectFrame(frameSize = (0,.8,0,.4), frameColor=(0,0,0,.5),
						pos = (xpos-.2,0, .7)) 
							
		self.info = OnscreenText(text=self.user.username,
				      style=1, fg=(1,1,1,1),
				      pos=(xpos-.1,.95), scale = .04,
				      align=TextNode.ARight,mayChange=1,)
		self.sector = OnscreenText(text="SECTOR: "+str(self.terrain.sector),
				      style=1, fg=(1,1,1,1),
				      pos=(xpos,0.95), scale = .04,
				      align=TextNode.ALeft,mayChange=1,)
		self.secxy = OnscreenText(text="",
				      style=1, fg=(1,1,1,1),
				      pos=(xpos,0.90), scale = .04,
				      align=TextNode.ALeft,mayChange=1,)
		self.elev = OnscreenText(text="",
				      style=1, fg=(1,1,1,1),
				      pos=(xpos,0.85), scale = .03,
				      align=TextNode.ALeft,mayChange=1,)
		self.head = OnscreenText(text="",
				      style=1, fg=(1,1,1,1),
				      pos=(xpos,0.80), scale = .03,
				      align=TextNode.ALeft,mayChange=1,)
		self.info.reparentTo(aspect2d)
		self.sector.reparentTo(aspect2d)
		self.secxy.reparentTo(aspect2d)
		self.elev.reparentTo(aspect2d)
		self.head.reparentTo(aspect2d)
		
	def runCommand(self):
		rep=(0,100,0,100)
		com="self.setPos(%s,%s,self.terrain.getRealElev(%s,%s))"
		try:
			eval(com % rep)
		except:	
			print 'could not run function'
			
	def runMagic(self,magic,invars):
		print 'input',magic,invars,self.user.MYDIR
		(magic,status)=self.getMagic(magic,invars)
		if status=='GOOD':
			try:
				exec magic
			except:
				print 'could not run magic'
		else:
			print status
				    
	def getMagic(self,magic,invars):
		status='GOOD'
		try:
			mfile=open(self.user.MYDIR+'/magic/'+magic+'.magic','r')
		except:
			status='Could not open magic file'
		if status=='GOOD':	
			try:	
				magic=mfile.read()
			except:
				status='Could not read magic file'
		if invars!=None and status=='GOOD':				
			try:	
				(magv,maginput)=self.getMagicVars(magic)
				magvars={}
				for i in range(len(magv)):
					magvars[magv[i]]=invars[i]	
				
				for i in range(len(maginput)):
					maginput[i]=magvars[maginput[i]]
				magic= magic % tuple(maginput)
			except:
				status='Could not parse magic variables'
		return magic,status		
			
	def getMagicVars(self,magic):		
		magparts=magic.strip('#').split("\n")
		magparts=magparts[0].split('||')
		magv=magparts[0].split(',')
		maginput=magparts[1].split('/')
		return magv,maginput
		
	def mouseClick(self,LR):
		mpos=base.mouseWatcherNode.getMouse()
		print 'moused',LR,mpos
		#This makes the ray's origin the camera and makes the ray point 
   		#to the screen coordinates of the mouse
   		self.pickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())
		entries=self.mouseHandler.getNumEntries()
		if  entries > 0:
			self.mouseHandler.sortEntries() #this is so we get the closest object
			print 'num of entries',entries
			for i in range(entries):
				print 'entry',i,self.mouseHandler.getEntry(0)
			pickedEntry=self.mouseHandler.getEntry(0)
			pickedColl=pickedEntry.getInto()
			pickedNP=pickedEntry.getIntoNodePath()
			print 'picked',pickedColl,pickedNP.getPos(),pickedNP.getName(),
			self.mouseHandler.clearEntries()
			if pickedNP.getName().find('Terrain')>-1:
				if LR=='R':
					self.terrain.startNewModel(pickedEntry.getSurfacePoint(render))
				else:	
					print 'no function here for mouse'
			else:
				print 'clicked on:',pickedNP.getName()
		      
	def move(self, task):
		elapsed = task.time - self.prevtime
		if (self.count % 1000 == 0):
			self.terrain.setSuns()
		#print elapsed
		# If the camera-left key is pressed, move camera left.
		# If the camera-right key is pressed, move camera right.
		
		#movement=False
		#cammove=False
		self.headchange=False   
		self.keyed=False
		self.cammove=False
		if self.accepting==True:
			for k,v in self.keyMap.iteritems():
				if v==1:                  
					self.keyed=True
					break
			if self.keyed==True:
				if self.ooBody==False:
					if self.firstperson==False:
						#self.myCAM.lookAt(self.getX(),self.get(Y),)
						camright = self.myCAM.getNetTransform().getMat().getRow3(0)
						camright.normalize()
						if (self.keyMap["cam-right"]!=0):
							self.cammove=True	
							self.myCAM.setFluidPos(self.myCAM.getPos() - camright*(elapsed*10))
							#if self.myCAM.getZ()<self.getZ():
							#	self.myCAM.setZ(self.getZ())
							#print self.myCAM.getPos()
						if (self.keyMap["cam-left"]!=0):
							self.cammove=True
							self.myCAM.setFluidPos(self.myCAM.getPos() + camright*(elapsed*10))
							#if self.myCAM.getZ()<self.getZ():
							#	self.myCAM.setZ(self.getZ())
							#print self.myCAM.getPos()
				# save ralph's initial position so that we can restore it,
				# in case he falls off the map or runs into something.
			
				startpos = self.getPos()
				
				# If a move-key is pressed, move ralph in the specified direction.
				
				if (self.keyMap["left"]!=0):
					self.headchange=True
					self.turnL(elapsed)
				if (self.keyMap["right"]!=0):
					self.headchange=True
					self.turnR(elapsed)
				if (self.keyMap["forward"]!=0):
					self.headchange=True
					if self.ooBody==False:
						self.cammove=True
					self.runAnim()
					self.forw(elapsed)
					if self.count % 20==0:
						print 'height',self.getZ()
				if (self.keyMap["back"]!=0):
					self.headchange=True
					if self.ooBody==False:
						self.cammove=True
					self.runAnim()
					self.back(elapsed)
				
				if (self.keyMap["jump"]!=0):   
					self.headchange=True
					if self.ooBody==False:
						self.cammove=True
					self.runAnim()   
					self.jump(elapsed)
					
				if (self.keyMap["moused1"]!=0):   
					self.mouseClick('L')	
				if (self.keyMap["moused2"]!=0):   
					self.mouseClick('C')	
				if (self.keyMap["moused3"]!=0):   
					self.mouseClick('R')	
					 
				if self.headchange==True:	
					self.headChange()
					if self.firstperson==True:
						self.myCAM.setH(self.getH()-180)
						angle=(self.getH()/360)*2*math.pi
						self.myCAM.setFluidPos(math.cos(angle)+self.getX(),math.sin(angle)+self.getY(),self.getZ()+self.height)
				if self.isMoving==True:
					self.HUDInfo()
					nowZ=self.getZ()
					self.cTrav.traverse(render)
					if nowZ-self.getZ()>50 and self.getZ()- self.terrain.SEALEVEL<10:
						print 'now,then',nowZ,self.getZ(),self.terrain.SEALEVEL,self.terrain.getRealElev(self.getX(),self.getY())	
						self.setFluidPos(self.getX(),self.getY(),nowZ)
					
		
							
				if self.cammove==True:
					if self.firstperson==False:
						camvec = self.getPos() - self.myCAM.getPos()
						camvec.setZ(0)
						camdist = camvec.length()
						camvec.normalize()
						if self.isFlying==True:
							cammax=100
							cammin=5
							camlow=5
							camhi=30
						else:
							cammax=20
							cammin=10
							camlow=self.height-1
							camhi=self.height*1.5	
						if (camdist > cammax):
							self.myCAM.setFluidPos(self.myCAM.getPos() + camvec*(camdist-cammax))
							camdist = cammax
						if (camdist < cammin):
							self.myCAM.setFluidPos(self.myCAM.getPos() - camvec*(cammin-camdist))
							camdist = cammin
						if (self.myCAM.getZ() < self.getZ() + camlow):
							self.myCAM.setZ(self.getZ() + camlow)
						elif (self.myCAM.getZ() > self.getZ() + camhi):
							if self.myCAM.getZ() - self.getZ()> 200:
								self.myCAM.setZ(self.getZ()+camhi)
							else:	
								self.myCAM.setZ(self.myCAM.getZ()-3)	
					else:		
						self.myCAM.setFluidPos(self.getX(),self.getY(),self.getZ()+self.height)
					# Check collisions.
				
					entries = []
					for i in range(self.camGroundHandler.getNumEntries()):
						entry = self.camGroundHandler.getEntry(i)
						entries.append(entry)
					entries.sort(lambda x,y: cmp(y.getSurfacePoint(render).getZ(),
									 x.getSurfacePoint(render).getZ()))
					
					# this needs to be fixed for camera !!!!
					#if (len(entries)>0):
					#	zadjust=self.getTerrainCollides(entries)+3
									 
					#if (len(entries)>0) and (entries[0].getIntoNode().getName() == "terrain"):
					#    self.myCAM.setZ(entries[0].getSurfacePoint(render).getZ()+1.0)
						
					#if (base.camera.getZ() < self.ralph.getZ() + 2.0):
					#    self.myCAM.setZ(self.ralph.getZ() + 2.0)
						
		
				#print "KEY"
			else:
				self.walkAnim()
			if self.firstperson==False:	
				self.myCAM.lookAt(self.getX(),self.getY(),self.getZ()+self.height/2)
			#else:
			#   self.walkAnim()
			# Store the task time and continue.
			
		self.count+=1
		self.prevtime = task.time
		#self.keyed=False	
		self.setXYZ()
		return Task.cont
		
	def getCollides(self,entries,ctype):
		bounce=False
		for e in entries:
			if e.getIntoNode().getName()!='':
					name=e.getIntoNode().getName()
					#print ctype+" collide:",name
					if name.count('Wall')==1:
						print 'wall collide'
						bounce=True
						break
						
		return bounce				
					

	
	def quickZAdjust(self,seahgt,terrhgt):	
		if seahgt>terrhgt:
			zadjust=seahgt-.5
		else:
			zadjust=terrhgt	
		return zadjust	
		
	def turnLFixed(self,amount):
		self.headchange=True
		self.keyed=True
		self.setH(self.getH() + amount)
		self.isMoving=False
	def turnRFixed(self,amount):
		self.headchange=True
		self.keyed=True
		self.setH(self.getH() - amount)
	def stopTurn(self):	
		self.headchange=True
		self.keyed=False
		
	def stopMove(self):	
		print "stop"
		self.cammove=False
		self.keyed=False
		self.walkAnim()
		
	def turnL(self,elapsed):
		self.setH(self.getH() + 50*elapsed)
	def turnR(self,elapsed):
		self.setH(self.getH() - 50*elapsed)
	def forw(self,elapsed):
		backward = self.getNetTransform().getMat().getRow3(1)
		backward.setZ(0)
		backward.normalize()
		if self.isFlying==True:
			self.setFluidPos(self.getPos() - backward*(elapsed*100))
		else:
			self.setFluidPos(self.getPos() - backward*(elapsed*self.height))
	def back(self,elapsed):
		backward = self.getNetTransform().getMat().getRow3(1)
		backward.setZ(0)
		backward.normalize()
		if self.isFlying==True:
			self.setFluidPos(self.getPos() + backward*(elapsed*100))
		else:
			self.setFluidPos(self.getPos() + backward*(elapsed*self.height))
		    
	def jump(self,elapsed):
		self.setZ(self.getZ() + 10)    
		backward = self.getNetTransform().getMat().getRow3(1)
		backward.setZ(0)
		backward.normalize()
		self.setFluidPos(self.getPos() - backward*(elapsed*100))
	
	def HUDInfo(self):
		if (int(self.getX())<0):
			xTxt='RedSet '+str(abs(int(self.getX())))
		elif (int(self.getX())==0):
			xTxt=str(int(self.getX()))
		elif (int(self.getX())>0):
			xTxt='RedRise '+str(int(self.getX()))
		if (int(self.getY())<0):
			yTxt='GreenSet '+str(abs(int(self.getY())))
		elif (int(self.getY())==0):
			yTxt=str(int(self.getY()))
		elif (int(self.getY())>0):
			yTxt='GreenRise '+str(int(self.getY()))
			
		self.sector['text']="SECTOR:\t"+ yTxt+"\n\t"+xTxt
		self.secxy['text']=str(int(self.rX))+':'+str(int(self.rY))
		self.elev['text']="ELEV:"+str(int((self.getZ()-self.terrain.SEALEVEL)*10)/10)
	
	def headChange(self):	
		head=int(self.getH()) % 360
		if (head<45 or head>=315):
			heading='Gs'
			if head <180:
				if head>15:
					if head>30:
						heading+='Rr'
					else:	
						heading+='GsRr'
			else:
				if head<330:
					heading+='Rs'
				elif head<345:
					heading+='Rs'
					
					
		elif (head>=45 and head<135):
			if head<60:
				heading='GsRr'
			elif head>=120:
				heading='GrRr'
			else:	
				heading='Rr'
				if head<75:
					heading+='GsRr'
				else:
					if head>=105:
						if head<120:
							heading+='GrRr'
		elif (head>=135 and head<225):
			heading='Gr'
			if (head<165 or head>=195): 
				if head<150:
					heading+='Rr'
				elif head<165:
					heading+='GrRr'
				else:
					if head<210:
						heading+='GrRs'
					else:
						heading+='Rs'
						
		elif (head>=225 and head<315):
			if head<240:
				heading='GrRs'
			elif head>=300:
				heading='GsRs'
			else:	
				heading='Rs'
				if head<255:
					heading+='GrRs'
				else:
					if head>=285:
						if head<300:
							heading+='GsRs'
							
		self.head['text']="HEAD:"+str(head)+"\t"+heading
		
	def getHeight(self):
	       pt1, pt2 = self.getTightBounds()
	       modelZDim = pt2.getZ() - pt1.getZ()
	       self.height=modelZDim 
	       print 'avatar height',self.height
	       
	def takePhoto(self,name):
		base.win.saveScreenshot(Filename(name))
		#screenshot()
		
	def setBodyParts(self):
		self.skeleton=self.controlJoint(None,"modelRoot","Skeleton")
		self.chest=self.controlJoint(None,"modelRoot","Chest")
		self.lshoulder=self.controlJoint(None,"modelRoot","LeftShoulder")
		self.rshoulder=self.controlJoint(None,"modelRoot","RightShoulder")
		self.lelbow=self.controlJoint(None,"modelRoot","LeftElbow")
		self.relbow=self.controlJoint(None,"modelRoot","RightElbow")
		self.lwrist=self.controlJoint(None,"modelRoot","LeftWrist")
		self.rwrist=self.controlJoint(None,"modelRoot","RightWrist")
		self.lhand=self.controlJoint(None,"modelRoot","LeftHand")
		self.rhand=self.controlJoint(None,"modelRoot","RightHand")
		self.neck=self.controlJoint(None,"modelRoot","Neck")
		self.headbone=self.controlJoint(None,"modelRoot","HeadBone")
		self.leyelid=self.controlJoint(None,"modelRoot","LeftEyeLid")
		self.reyelid=self.controlJoint(None,"modelRoot","RightEyeLid")
		self.jaw=self.controlJoint(None,"modelRoot","Jaw")
		self.lcheek=self.controlJoint(None,"modelRoot","LeftCheek")
		self.rcheek=self.controlJoint(None,"modelRoot","RightCheek")
		self.toplip=self.controlJoint(None,"modelRoot","TopLip")
		self.lhip=self.controlJoint(None,"modelRoot","LeftHip")
		self.rhip=self.controlJoint(None,"modelRoot","RightHip")
		self.lknee=self.controlJoint(None,"modelRoot","LeftKnee")
		self.rknee=self.controlJoint(None,"modelRoot","RightKnee")
		self.lankle=self.controlJoint(None,"modelRoot","LeftAnkle")
		self.rankle=self.controlJoint(None,"modelRoot","RightAnkle")
		self.lball=self.controlJoint(None,"modelRoot","LeftBall")
		self.rball=self.controlJoint(None,"modelRoot","RightBall")
		self.ltoe=self.controlJoint(None,"modelRoot","LeftToe")
		self.rtoe=self.controlJoint(None,"modelRoot","RightToe")
	
