__author__='sigilis.com'
__version__='0.1'
from direct.actor.Actor import Actor
from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import Vec3, GeomNode
from direct.task.Task import Task
from direct.gui.OnscreenText import OnscreenText
from pandac.PandaModules import PandaNode,NodePath,Camera,TextNode    
from pandac.PandaModules import CollisionTraverser,CollisionNode
from pandac.PandaModules import CollisionHandlerQueue,CollisionRay,BitMask32
from pandac.PandaModules import CollisionSphere,CollisionSegment
from pandac.PandaModules import Filename,EggData
from pandac.PandaModules import Mat4D
from libs.ConfigFile import *
from direct.gui.DirectGui import DirectSlider
import math

VIZRAD=100000

class Edatar(Actor,DirectObject):
	def __init__(self,user=None,terrain=None,
			sx=None,sy=None,sz=None,eyeheight=None):
		self.user=user		
		models="avatars/%s" % self.user.modelType		
		anims= {"run":"models/%s-run" % self.user.modelType,
			"walk":"models/%s-walk" % self.user.modelType
			}
		
		self.keyMap = {"cam-left":0, "cam-right":0}	
		self.ed=EggData()
		print 'before eggfile read'
		avegg=Filename(models+'.egg')
		self.ed.setEggFilename(avegg)
		self.ed.read(avegg)
		print 'eggfile',self.ed.getEggFilename()
		Actor.__init__(self,models,anims)
		self.setMoveKeys()		
		self.cammove=False
		self.keyed=False
		self.eyeheight=eyeheight
		if sx!=None and sy!=None:
			self.reparentTo(render)
			self.terrain=terrain
			if sz==None:
				StartPos=Vec3(sx,sy,self.terrain.getRealElev(sx,sy))
			else:
				StartPos=Vec3(sx,sy,sz)
			self.setFluidPos(StartPos)
			self.myCAM=base.camera
			self.myCAMLENS=base.camLens
			self.myCAM.setPos(self.getX(),self.getY()-10,self.getZ()+6)
			self.myCAMLENS.setFar(VIZRAD)
			self.myCAM.lookAt(self)
			#taskMgr.add(self.move,"moveTask")
			self.prevtime = 0
			self.count=0
			#self.ls()
			#print 'AVATAR',self.getPos()
			#print 'CAM',self.myCAM.getPos()
			self.heightslider=DirectSlider(range=(.1,3),value=1,pageSize=.1,
							command=self.setHeight,orientation='vertical',
							frameSize=(-0.02, 0.02, -.5, .5),
							frameVisibleScale=(1, 1),
							thumb_frameSize=(-.02, .02,-.02, .02),
							pos=(1.0,0,0),
							scale=(.5,1,1))
			self.heightslider.setScrollSize()
			self.heightslider.setOrientation()
			self.setBodyParts()

	#Records the state of the arrow keys
    	def setKey(self, key, value):
	    	self.keyMap[key] = value	
		
	def setMoveKeys(self):
		self.accept("arrow_left", self.camLeft,[1])
		self.accept("arrow_right", self.camRight,[1])
		self.accept("arrow_left-repeat", self.camLeft,[3])
		self.accept("arrow_right-repeat", self.camRight,[3])
		self.accept("page_up", self.taller)
		self.accept("page_down", self.shorter)
		self.accept("page_up-repeat", self.taller)
		self.accept("page_down-repeat", self.shorter)
		self.accept("home", self.fatter)
		self.accept("end", self.thinner)
		self.accept("home-repeat", self.fatter)
		self.accept("end-repeat", self.thinner)
		self.accept("control-s", self.saveEgg)
		magicVARS=['Run',None]
		self.accept("control-m",self.runMagic,magicVARS)
		
	def camLeft(self,amt):
		camright = self.myCAM.getNetTransform().getMat().getRow3(0)
		camright.normalize()	
		#print 'CAMbefore',self.myCAM.getPos()
		self.myCAM.setPos(self.myCAM.getPos() - camright*amt)
		#print 'CAMafter',self.myCAM.getPos()
		self.camAlter()
		
	def camRight(self,amt):	
		camright = self.myCAM.getNetTransform().getMat().getRow3(0)
		camright.normalize()
		self.myCAM.setPos(self.myCAM.getPos() + camright*amt)
		self.camAlter()		
		
	def camAlter(self):
		#print 'CAMstart',self.myCAM.getPos()
		camvec = self.getPos() - self.myCAM.getPos()
		camvec.setZ(0)
		camdist = camvec.length()
		camvec.normalize()
		if (camdist > 10.0):
		    self.myCAM.setPos(self.myCAM.getPos() + camvec*(camdist-10))
		    camdist = 10.0
		if (camdist < 2.0):
		    self.myCAM.setPos(self.myCAM.getPos() - camvec*(2-camdist))
		    camdist = 2.0
		if (self.myCAM.getZ() < self.getZ() + 5.5):
			self.myCAM.setZ(self.myCAM.getZ()+.1)
		elif (self.myCAM.getZ() > self.getZ() + 6.5):
			self.myCAM.setZ(self.getZ() -.1)	
		self.myCAM.lookAt(self.getX(),self.getY(),self.getZ()+3)	
		#print 'CAMend',self.myCAM.getPos()
			
	def taller(self):
		self.setScale(Vec3(self.getScale().getX(),self.getScale().getY(),self.getScale().getZ()+.1))
		self.ed.transform(Mat4D.scaleMat(self.getScale().getX(),self.getScale().getY()+.1,self.getScale().getZ()))
	def shorter(self):
		self.setScale(Vec3(self.getScale().getX(),self.getScale().getY(),self.getScale().getZ()-.1))
		self.ed.transform(Mat4D.scaleMat(self.getScale().getX(),self.getScale().getY()-.1,self.getScale().getZ()))
	def setHeight(self):		
		self.setScale(Vec3(self.getScale().getX(),self.getScale().getY(),self.heightslider['value']) )
		self.ed.transform(Mat4D.scaleMat(self.getScale().getX(),self.heightslider['value'],self.getScale().getZ()))
	def fatter(self):
		self.setScale(Vec3(self.getScale().getX()+.1,self.getScale().getY()+.1,self.getScale().getZ()))
		self.ed.transform(Mat4D.scaleMat(self.getScale().getX()+.1,self.getScale().getY(),self.getScale().getZ()+.1))
	
	def thinner(self):
		self.setScale(Vec3(self.getScale().getX()-.1,self.getScale().getY()-.1,self.getScale().getZ()))
		self.ed.transform(Mat4D.scaleMat(self.getScale().getX()-.1,self.getScale().getY(),self.getScale().getZ()-.1))		
				
	def saveEgg(self):
		self.ed.writeEgg(Filename("avatars/newavatar.egg"))
		confav=UpdateConfigFile('modelType','newavatar',self.user.MYDIR)
			
	def runMagic(self,magic,invars):
		print 'input',magic,invars,self.user.MYDIR
		(magic,status)=self.getMagic(magic,invars)
		if status=='GOOD':
			try:
				exec magic
			except:
				print 'could not run magic'
		else:
			print status
				    
	def getMagic(self,magic,invars):
		status='GOOD'
		try:
			mfile=open(self.user.MYDIR+'/magic/'+magic+'.magic','r')
		except:
			status='Could not open magic file'
		if status=='GOOD':	
			try:	
				magic=mfile.read()
			except:
				status='Could not read magic file'
		if invars!=None and status=='GOOD':				
			try:	
				(magv,maginput)=self.getMagicVars(magic)
				magvars={}
				for i in range(len(magv)):
					magvars[magv[i]]=invars[i]	
				
				for i in range(len(maginput)):
					maginput[i]=magvars[maginput[i]]
				magic= magic % tuple(maginput)
			except:
				status='Could not parse magic variables'
		return magic,status		
			
	def getMagicVars(self,magic):		
		magparts=magic.strip('#').split("\n")
		magparts=magparts[0].split('||')
		magv=magparts[0].split(',')
		maginput=magparts[1].split('/')
		return magv,maginput

	def setBodyParts(self):
		self.skeleton=self.controlJoint(None,"modelRoot","Skeleton")
		self.chest=self.controlJoint(None,"modelRoot","Chest")
		self.lshoulder=self.controlJoint(None,"modelRoot","LeftShoulder")
		self.rshoulder=self.controlJoint(None,"modelRoot","RightShoulder")
		self.lelbow=self.controlJoint(None,"modelRoot","LeftElbow")
		self.relbow=self.controlJoint(None,"modelRoot","RightElbow")
		self.lwrist=self.controlJoint(None,"modelRoot","LeftWrist")
		self.rwrist=self.controlJoint(None,"modelRoot","RightWrist")
		self.lhand=self.controlJoint(None,"modelRoot","LeftHand")
		self.rhand=self.controlJoint(None,"modelRoot","RightHand")
		self.neck=self.controlJoint(None,"modelRoot","Neck")
		self.headbone=self.controlJoint(None,"modelRoot","HeadBone")
		self.leyelid=self.controlJoint(None,"modelRoot","LeftEyeLid")
		self.reyelid=self.controlJoint(None,"modelRoot","RightEyeLid")
		self.jaw=self.controlJoint(None,"modelRoot","Jaw")
		self.lcheek=self.controlJoint(None,"modelRoot","LeftCheek")
		self.rcheek=self.controlJoint(None,"modelRoot","RightCheek")
		self.toplip=self.controlJoint(None,"modelRoot","TopLip")
		self.lhip=self.controlJoint(None,"modelRoot","LeftHip")
		self.rhip=self.controlJoint(None,"modelRoot","RightHip")
		self.lknee=self.controlJoint(None,"modelRoot","LeftKnee")
		self.rknee=self.controlJoint(None,"modelRoot","RightKnee")
		self.lankle=self.controlJoint(None,"modelRoot","LeftAnkle")
		self.rankle=self.controlJoint(None,"modelRoot","RightAnkle")
		self.lball=self.controlJoint(None,"modelRoot","LeftBall")
		self.rball=self.controlJoint(None,"modelRoot","RightBall")
		self.ltoe=self.controlJoint(None,"modelRoot","LeftToe")
		self.rtoe=self.controlJoint(None,"modelRoot","RightToe")
		
	
