__author__='sigilis.com'
__version__='0.1.1'
from direct.showbase.DirectObject import DirectObject
from BasicFunctions import addSplashLine
from World import World
from EditWorld import EditWorld
from pandac.PandaModules import WindowProperties
from libs.ConfigFile import *

import sys

class StartSplash(DirectObject):
	def __init__(self,me,MYDIR):
		self.accept("escape", sys.exit)
		self.mainScreen(me)
		self.MYDIR=MYDIR
	
	def startWorld(self,me):
		self.goworld.destroy()
		self.goedit.destroy()
		self.gores.destroy()
		w= World(me,self.MYDIR)
		self.ignoreAll()
		
	def startEdit(self,me):
		self.goworld.destroy()
		self.goedit.destroy()
		self.gores.destroy()
		ew= EditWorld(me)
		self.ignoreAll()
		
	def mainScreen(self,me):	
		self.goworld=addSplashLine(0.90, "[1]: Go to World")
		self.goedit=addSplashLine(0.85, "[2]: Edit Avatar")
		self.gores=addSplashLine(0.80, "[3]: Resolution")
		self.accept("1", self.startWorld,[me])
		self.accept("2", self.startEdit,[me])
		self.accept("3", self.resolutionScreen,[me])
		
	def resolutionScreen(self,me):	
		self.goworld.destroy()
		self.goedit.destroy()
		self.gores.destroy()
		self.go640=addSplashLine(0.90, "[1]: 640 x 480")
		self.go800=addSplashLine(0.85, "[2]: 800 x 600")
		self.go1024=addSplashLine(0.80, "[3]: 1024 x 600")
		self.go1024b=addSplashLine(0.75, "[4]: 1024 x 768")
		self.go1280=addSplashLine(0.70, "[5]: 1280 x 768")
		self.go1280b=addSplashLine(0.65, "[6]: 1280 x 800")
		self.go1600=addSplashLine(0.60, "[7]: 1440 x 900")
		self.go1600=addSplashLine(0.60, "[8]: 1600 x 1200")
		self.goMain=addSplashLine(0.55, "[9]: Return to Main Screen")
		self.accept("1", self.setRes,[640,480])
		self.accept("2", self.setRes,[800,600])
		self.accept("3", self.setRes,[1024,600])
		self.accept("4", self.setRes,[1024,768])
		self.accept("5", self.setRes,[1280,768])
		self.accept("6", self.setRes,[1280,800])
		self.accept("7", self.setRes,[1440,900])
		self.accept("8", self.setRes,[1600,1200])
		self.accept("9", self.returnMain,['resolutionScreen',me])
		
	def returnMain(self,fromScreen,me):
		if fromScreen=='resolutionScreen':			
			self.go640.destroy()
			self.go800.destroy()
			self.go1024.destroy()
			self.go1024b.destroy()
			self.go1280.destroy()
			self.go1280b.destroy()
			self.go1600.destroy()
			self.goMain.destroy()
			self.mainScreen(me)
			
	def setRes(self,x,y):
		wp = WindowProperties()
		wp.setSize(x,y)
		base.win.requestProperties(wp)		
		confx=UpdateConfigFile('screenx',str(x),self.MYDIR)
		confy=UpdateConfigFile('screeny',str(y),self.MYDIR)
		print 'config',confx,confy
		
		
