__author__='sigilis.com'
__version__='0.1.4'
from pandac.PandaModules import Filename,NodePath
from pandac.PandaModules import HeightfieldTesselator
from pandac.PandaModules import TextureStage,TransformState,Vec3
from pandac.PandaModules import Texture,TexGenAttrib
from pandac.PandaModules import CollisionNode,BitMask32
from direct.gui.DirectScrolledList import DirectScrolledList
from direct.gui.DirectButton import DirectButton
from pandac.PandaModules import GeoMipTerrain

from modelclasses.Tree import Tree
from modelclasses.SigilisModel import SigilisModel

from BasicFunctions import getSunPos

import os,fnmatch



class Terrain():
	def __init__(self,world,sector=None,
			hscale=None,vscale=None,vizrad=None,MYDIR=None):
		self.objects=NodePath('Objects')
		self.objects.reparentTo( render )
		self.objects.setPos(0,0,0)
		print self.objects.node
		
		self.sector=sector
		self.x0=-512*hscale
		self.y0=512*hscale
		self.world=world
		dry="models/maps/sector%s.png" % sector  
		print "DRY",dry
		wet='models/maps/watermap.png'
		drytext='textures/ground.jpg'
		wettext='textures/water.png'
		self.sea = HeightfieldTesselator( 'Sea' )
		self.sea.setHeightfield( Filename(wet) )
		self.sea.setHorizontalScale( hscale *4 )
		self.sea.setVerticalScale( vscale )
		self.SEALEVEL=self.sea.getElevation(1,1)*vscale
		print "SEALEVEL:",self.SEALEVEL
		print "PRESEA:",self.sea.getElevation(1,1)
		self.land=HeightfieldTesselator( 'Terrain' )
		self.land.setHeightfield( Filename(dry) )
		self.land.setHorizontalScale( hscale )
		self.land.setVerticalScale( vscale )
		self.land.setVisibilityRadius(vizrad)
		self.hscale=hscale
		self.vscale=vscale
		self.MYDIR=MYDIR

		#self.land = GeoMipTerrain("Terrain")
		#self.land.setHeightfield(Filename(dry))
		#self.land.setColorMap(Filename(dry))
		#terrain.setBruteforce(True)
		#self.ground=self.land.getRoot()
		#self.ground.reparentTo(render)
		#self.ground.setScale(hscale,hscale,vscale)
		
		
		self.ground = self.land.generate( )
		
		#self.ground.node().setIntoCollideMask(BitMask32.bit(0))
		grass=TextureStage('Grass')
		grass.setSort(0)
		self.ground.setTexGen( grass, TexGenAttrib.MWorldPosition )
		self.ground.setTexGen( grass, TexGenAttrib.MWorldPosition )
		
		self.ground.setTexScale( grass, 0.25, 0.25 )
		self.ground.setTexture( grass,loader.loadTexture(drytext) )
		#self.ground.setIntoCollideMask(BitMask32.bit(20))
		
		#self.ground.setCollideMask()
		#print "collide",self.ground.getCollideMask()
		for i in range(0,self.ground.getNumNodes()):
			print self.ground.getNumNodes(),self.ground.getNode(i)
		

		self.runRoads('sector'+str(sector),None)
		

		
		self.ground.reparentTo( render )
		self.ground.setPos( self.x0, self.y0, 0 )
		#self.land.generate()
		
		self.water = self.sea.generate( )
		self.water.setTexGen( TextureStage.getDefault( ), TexGenAttrib.MWorldPosition )
		self.water.setTexScale( TextureStage.getDefault( ), 1.0, 1.0 )
		self.water.setTexture( loader.loadTexture(wettext) )
		self.water.reparentTo( render )
		self.water.setPos( self.x0, self.y0, 0 )
		
		print "ground collide",self.ground.getCollideMask()
		print "water collide",self.water.getCollideMask()
		

		
	def getRealElev(self,x,y):
		elev=self.land.getElevation((x-self.x0)/self.hscale,(self.y0-y)/self.hscale)*self.vscale
		print "ELEVATION",elev
		return elev
		
	def getTerrainXY(self,x,y):
		terx=int((x-self.x0)/self.hscale);
		tery=int((self.y0-y)/self.hscale);    
		return terx,tery
		
	def drawModel(self,model):
		if (model['type']=='Tree'):
			self.drawTree(model['data'])
		else:
			impStr='from modelclasses.'+model['type']+' import '+model['type']
			try:
				exec(impStr)
				success=True
			except:
				print 'could not import Model',impStr
				success=False
			if success==True:
				print self.world.me
				execStr='model='+model['type']+"(model['data'],self.world.me)"
				#model=eval(model['type']+"(model['data'],self.world.me)")
				exec(execStr)
		
	def drawTree(self,data):
		Tree(data)
		
	def runRoads(self,roadfile,invars):
		#print 'input',magic,invars,self.user.MYDIR
		(roads,status)=self.getRoads(roadfile,invars)
		if status=='GOOD':
			try:
				exec roads
			except:
				print 'could not run magic'
		else:
			print status
				    	    
	def getRoads(self,roadfile,invars):
		status='GOOD'
		try:
			mfile=open(self.MYDIR+'/roads/'+roadfile+'.py','r')
		except:
			status='Could not open road file'
		if status=='GOOD':	
			try:	
				roadfile=mfile.read()
			except:
				status='Could not read magic file'
		#if invars!=None and status=='GOOD':				
		#	try:	
		#		(magv,maginput)=self.getMagicVars(magic)
		#		magvars={}
		#		for i in range(len(magv)):
		#			magvars[magv[i]]=invars[i]	
		#		
		#		for i in range(len(maginput)):
		#			maginput[i]=magvars[maginput[i]]
		#		magic= magic % tuple(maginput)
		#	except:
		#		status='Could not parse magic variables'
		return roadfile,status	
	
	def startNewModel(self,surfacePoint):
		buttons=[]
		for file in os.listdir(self.MYDIR+'/modelclasses'):
			if fnmatch.fnmatch(file, '*.py'):
				file= file[:-3]
				if file != '__init__' and file != 'SigilisModel':
					buttons.append( DirectButton(	text = ("add "+file, "click!", "add "+file, "disabled"),
							text_scale=0.05, borderWidth = (0.01, 0.01),
							relief=2,command=SigilisModel.createModelFrame,
							extraArgs=[SigilisModel(),file,surfacePoint]) )
					

		numItemsVisible = 4
		itemHeight = 0.11			
		modelList= DirectScrolledList(	decButton_pos= (0.35, 0, 0.53),
						decButton_text = "up",
						decButton_text_scale = 0.04,
						decButton_borderWidth = (0.005, 0.005),
						
						incButton_pos= (0.35, 0, -0.02),
						incButton_text = "down",
						incButton_text_scale = 0.04,
						incButton_borderWidth = (0.005, 0.005),
						
						frameSize = (0.0, 0.8, -0.05, 0.59),
						frameColor = (1,0,0,0.5),
						pos = (-1, 0, 0),
						items = buttons,
						numItemsVisible = numItemsVisible,
						forceHeight = itemHeight,
						itemFrame_frameSize = (-0.2, 0.2, -0.37, 0.11),
						itemFrame_pos = (0.35, 0, 0.4)
						)

	def setSuns(self):
		(redSunPos,greenSunPos,blueSunPos,skyColor)=getSunPos()
		base.setBackgroundColor( skyColor )
		self.world.redSunLight.setPoint(redSunPos)
		self.world.grnSunLight.setPoint(greenSunPos)
		self.world.bluSunLight.setPoint(blueSunPos)
		print 'sun pos',redSunPos,greenSunPos,blueSunPos,skyColor
