__author__='sigilis.com'

__version__='0.1.1'

from pandac.PandaModules import Filename,InternalName

from pandac.PandaModules import Texture,TextureStage,MovieTexture

from pandac.PandaModules import Vec3

from pandac.PandaModules import Geom, GeomNode, GeomTrifans, GeomTristrips

from pandac.PandaModules import GeomVertexReader, GeomVertexWriter

from pandac.PandaModules import GeomVertexRewriter, GeomVertexData

from pandac.PandaModules import GeomVertexArrayFormat, GeomVertexFormat

from pandac.PandaModules import NodePath

from pandac.PandaModules import MovieAudio,MovieAudioCursor,AudioSound

from pandac.PandaModules import HTTPClient,URLSpec,MovieVideo,Ramfile



import urllib

import threading

from SigilisModel import SigilisModel



DEFAULTMOVIE='movies/default.mpg'



class MovieWall(SigilisModel): 

	def __init__(self,data=None):

		if data !=None:

			SigilisModel.__init__(self,data,'MovieWall')

			self.movie=data['movie']                       

			self.movie_remote=int(data['movie_remote'])

			self.movie_scale=float(data['movie_scale'])

			self.movieheight=float(data['movieheight'])

			self.moviewidth=float(data['moviewidth'])

			self.height=float(data['height'])

			self.heading=float(data['heading'])

			

			formatArray=GeomVertexArrayFormat()

			formatArray.addColumn(InternalName.make("drawFlag"), 1, Geom.NTUint8, Geom.COther)

	

			format=GeomVertexFormat(GeomVertexFormat.getV3n3cpt2())

			format.addArray(formatArray)

			self.format=GeomVertexFormat.registerFormat(format)



			self.screendata=GeomVertexData("inner vertices", self.format, Geom.UHStatic)



			self.screen=self.nPath			

			self.screen.node().setIntoCollideMask(GeomNode.getDefaultCollideMask())

			

			screenGeom=self.makeScreen()

			

			if self.movie_remote==1:

				self.localmovie='movies/'+self.movie.replace('://','.').replace('/','.')

				lfile=Filename.binaryFilename(self.localmovie)

				if lfile.exists():

					screenTexture=loader.loadTexture(self.localmovie)

				else:

					screenTexture=loader.loadTexture(DEFAULTMOVIE)

					getmovie=threading.Thread(name='GetMovie'+str(self.__x)+'-'+str(self.__y)+'-'+str(self.__z),target=self.getMovie)

					getmovie.start()

					#screenTexture=self.getRemoteMovie()

			else:	

				screenTexture=loader.loadTexture(self.movie)

			screenAudio=MovieAudio()

			screenAudio.get(Filename(self.movie))

			screenAudioC=MovieAudioCursor(screenAudio)

			#screenAudioSound=loader.loadMusic(self.movie)

			#screenAudioSound=loader.loadMusic('/h/Music/A-D/A Tribe Called Quest/A Tribe Called Quest  Scenario.mp3')

			screenAudioSound=loader.loadSfx(self.movie)

			screenTexture.synchronizeTo(screenAudioSound)

			screenAudioSound.setLoop(True)

			screenAudioSound.setVolume(1)

			screenAudioSound.play()

				#screenAudioC=screenAudio.open()

			

			screenTexture.setWrapU(Texture.WMClamp)

			screenTexture.setWrapV(Texture.WMClamp)

			self.screen.setTexture(screenTexture)

			self.screen.setTwoSided(False)

			self.screen.attachNewNode(screenGeom)

			

			self.screen.reparentTo( render )

			self.screen.setH(self.heading)

			self.screen.setPos( self.__x,self.__y,self.__z)

			

			self.screen.ls()

			

	def getVarSpec(self):

		return {'x':'float','y':'float','z':'float','heading':'float','width':'float','height':'float',

			'movie':'str','movie_remote':'int','movie_scale':'float',

			'moviewidth':'float','movieheight':'float',

			'style':'str','wrapU':'str','wrapV':'str'}

			

	def makeScreen(self):

		pow2=[2,4,8,16,32,64,128,256,512,1024,2048,4096]

		self.screenGeom=Geom(self.screendata)

		self.vertWriter=GeomVertexWriter(self.screendata, "vertex")

		self.normalWriter=GeomVertexWriter(self.screendata, "normal")

		self.colorWriter=GeomVertexWriter(self.screendata, "color")

		self.uvWriter=GeomVertexWriter(self.screendata, "texcoord")

		self.drawWriter=GeomVertexWriter(self.screendata, "drawFlag")

		

		self.vertWriter.setRow(0)

		self.colorWriter.setRow(0)

		self.uvWriter.setRow(0)

		self.normalWriter.setRow(0)

		self.drawWriter.setRow(0)

		

		self.width=(self.moviewidth/self.movieheight)*self.height;

		hmatch=wmatch=False

		for p in pow2:

			if p>self.movieheight and hmatch==False:

				self.hpow2=p

				hmatch=True

			if p>self.moviewidth and wmatch==False:

				self.wpow2=p

				wmatch=True

		for i in range(2):

			for j in range(2):

				position=Vec3(j*self.width, 0,i*self.height)

				self.vertWriter.addData3f(position)

				self.uvWriter.addData2f(j*self.moviewidth/self.wpow2, i*self.movieheight/self.hpow2)	

				self.colorWriter.addData4f(1.0, 1.0, 1.0, 0.0)

				position.normalize()

				self.normalWriter.addData3f(position)	

				

		screen=GeomTristrips(Geom.UHStatic)

		screen.addVertex(0)		

		screen.addVertex(1)

		screen.addVertex(3)

		screen.addVertex(2)	

		screen.addVertex(0)		

		screen.closePrimitive()

			

		print screen	

		self.screenGeom.addPrimitive(screen)

		self.screenGeom.decomposeInPlace()

		#wallGeom.unifyInPlace(4,False)

		screenGeomNode=GeomNode("FloorGeom:"+str(self.__x)+'-'+str(self.__y)+'-'+str(self.__z))

		screenGeomNode.addGeom(self.screenGeom)

			

		return screenGeomNode	

		

	def getMovie(self):

		self.movieLoaded=False

		#(loadfilename,loadheaders)=urllib.urlretrieve(self.movie,self.localmovie,self.movieWatch)

		(loadfilename,loadheaders)=urllib.urlretrieve(self.movie,self.localmovie)

		self.screen.setTexture(loader.loadTexture(loadfilename))

		

	def movieWatch(self,count=0,size=0,total=0):

		if self.movieLoaded==False:

			print 'moviecount',count*size,total

			if total>1000000:

				if count*size>999999:

					self.screen.setTexture(loader.loadTexture(self.localmovie))

					self.movieLoaded=True

			else:

				if count*size>total/4:

					self.screen.setTexture(loader.loadTexture(self.localmovie))

					self.movieLoaded=True

					

	def getRemoteMovie(self):

		movClient=HTTPClient()

		movURL=URLSpec(self.movie)

		print 'client,url',movClient,movURL

		movDoc=movClient.getDocument(movURL)

		#movRam=Ramfile()

		#movDoc.downloadToRam(movRam)

		print 'movdoc',movDoc,movDoc.isValid(),movDoc.getStatusCode()

		#movVid=MovieVideo.get(movDoc.getFilename())

		#print 'movvid',movVid

		#movTex=loader.loadTexture(movVid.getFilename())

		#movTex=Texture.read(movVid.getFilename())

		content=movDoc.readFile(False)

		print 'content',content

		movTex=MovieTexture()

		#movTex. Texture.TT2dTexture,

		#return Texture.read(movDoc.getFilename())

		return movTex

		

